function CourseData() {
	var _this = this;
	var screenDataArray=[];
	
	_this.createCourseData=function(_str){
		
		if(_str=="" || _str==null){
			initData();
			
		}else{
			var prevData=_str.split('-#-');
			APP.configObj.language.lang=prevData[0];
			APP.configObj.language.dir=prevData[1];
			screenDataArray=JSON.parse(prevData[2]);						
			APP.courseBookmark=prevData[3];	
			APP.prevBookmark = APP.courseBookmark;
			
			APP.coursePassDate = prevData[4];	
			
			//APP.isPreTestPassed = (prevData[5] === 'true');
			APP.prevScreenForCertificate =prevData[5];
			//APP.isEnterInTheatre = (prevData[7] === 'true');
			APP.iCertify = (prevData[6] === 'true');
      APP.inlineQuizObj = JSON.parse(prevData[7]);
			calInlineQuizObj();
		}					
	}
	_this.updateSuspendData=function(){
		if(APP.commonFunObj.isScorm()){	
			/* var assessmentData = '';		
			if(APP.globalQuizObj.isAvalable){
				updateUserQuizData();
				assessmentData += JSON.stringify(APP.userQuizData)+"-#-"+ APP.globalQuizObj.currentQuizId;				
			}
			//--profiler
			var pObj = {
				pr1: APP.userTopicSelectionObj.profilerOne,
				pr2: APP.userTopicSelectionObj.profilerTwo,
				uta: APP.userTopicSelectionObj.userSelectedTopicArr 
			}				
			//
			var str=APP.configObj.language.lang+"-#-"+APP.configObj.language.dir+"-#-"+JSON.stringify(screenDataArray)+"-#-"+APP.courseBookmark+"-#-"+JSON.stringify(pObj)+"-#-"+APP.coursePassDate+"-#-"+assessmentData; */
			var str=APP.configObj.language.lang+"-#-"+APP.configObj.language.dir+"-#-"+JSON.stringify(screenDataArray)+"-#-"+APP.courseBookmark+"-#-"+APP.coursePassDate+"-#-"+APP.prevScreenForCertificate+"-#-"+APP.iCertify+"-#-"+JSON.stringify(APP.inlineQuizObj); 
			
			return str;
		}
	}		
	
	_this.updateScreenData = function(_val, _obj){	
		var obj = _obj || APP.navData;
		
		screenDataArray[obj.moduleId].tp[obj.topicId].sc[obj.screenId].ud = _val;
		APP.dataComObj.updateUserData();
	}
	_this.updateScreenCompletion = function(_val, _obj){
		var obj = _obj || APP.navData;
		
		isComplete = _this.isScreenComplete(obj);
		if(isComplete){
			$(document).trigger(APP.eventObj.ON_SCREEN_COMPLETE);
		}else{
			screenDataArray[obj.moduleId].tp[obj.topicId].sc[obj.screenId].st = _val;		
			if(_val == '2'){
				$(document).trigger(APP.eventObj.ON_SCREEN_COMPLETE);
			}
			_this.updateAllModuleStatus();
						
			APP.dataComObj.updateUserData();
		}		
	}
	_this.resetScreenStatus = function(_val, _obj ){
		var obj = _obj || APP.navData;
		screenDataArray[obj.moduleId].tp[obj.topicId].sc[obj.screenId].st = _val;
		_this.updateAllModuleStatus();			
		APP.dataComObj.updateUserData();				
	}
	_this.setScreenStatus = function(_val, _obj){
		var obj = _obj || APP.navData;
		screenDataArray[obj.moduleId].tp[obj.topicId].sc[obj.screenId].st = _val;
		_this.updateAllModuleStatus();			
		APP.dataComObj.updateUserData();				
	}
	_this.getScreenStatus = function(_obj){
		var obj = _obj || APP.navData;
		return screenDataArray[obj.moduleId].tp[obj.topicId].sc[obj.screenId].st;					
	}
	_this.getScreenUserData = function(_obj){
		var obj = _obj || APP.navData;
		return screenDataArray[obj.moduleId].tp[obj.topicId].sc[obj.screenId].ud || {};					
	}
	_this.getScreenDataArray = function(){
		return screenDataArray;					
	}
	_this.getTopicStatus = function (_modId, _topicId){		
		return screenDataArray[_modId].tp[_topicId].st;		
	}
	
	_this.getModuleStatus = function (_modId){		
		return st = screenDataArray[_modId].st;		
	}
	
	_this.isScreenComplete = function(_obj){
		var obj = _obj || APP.navData;
		
		var complete = false;
		var st = screenDataArray[obj.moduleId].tp[obj.topicId].sc[obj.screenId].st;
		
		if(st == '2') {
			complete = true;
		}
		
		return complete;
	}
	_this.updateAllModuleStatus = function(){
		
		for(var i=0; i<screenDataArray.length; i++){			
			var currMod = screenDataArray[i];
				var topicNaCount = 0;
				var topicInCount = 0;
				var topicComCount = 0;
			for(var j=0; j<currMod.tp.length; j++){
				var currTopic = currMod.tp[j];
				var naCount = 0;
				var inCount = 0;
				var comCount = 0;
				for(var k=0; k<currTopic.sc.length; k++){
					var curr = currTopic.sc[k];
					if(curr.st == '0'){naCount++;}
					if(curr.st == '1'){inCount++;}
					if(curr.st == '2'){comCount++;}
				}
				
				if(naCount >= currTopic.sc.length ){currTopic.st = '0';}
				if(inCount >= 1 || comCount >= 1 ){currTopic.st = '1';}
				if(comCount >= currTopic.sc.length){currTopic.st = '2';}
				
				if(currTopic.st == '0'){topicNaCount++;}
				if(currTopic.st == '1'){topicInCount++;}
				if(currTopic.st == '2'){topicComCount++;}
				
			}	
			if(topicNaCount >= currMod.tp.length ){currMod.st = '0';}
			if(topicInCount >= 1 || topicComCount >= 1){currMod.st = '1';}
			if(topicComCount >= currMod.tp.length){currMod.st = '2';}
			
		}
	};
	_this.isTopicComplete = function (_modId, _topicId){
		var complete = false;
		var st = screenDataArray[_modId].tp[_topicId].st;
		if(st == '2'){
			complete = true;
		}
		return complete;
	}
	
	_this.isModuleComplete = function (_modId){
		var modId = _modId || APP.navData.moduleId;
		var complete = false;
		var st = screenDataArray[modId].st;
		if(st == '2'){
			complete = true;
		}
		return complete;
	}
	_this.getTopicProgress = function(_modId, _topicId){		
		var completed = 0;
		var obj = screenDataArray[_modId].tp[_topicId].sc;
		var total = obj.length; 			
		for(var k=0; k<total; k++){
			var curr = obj[k];			
			if(curr.st == '2'){
				completed ++;
			}
		}		
		return Math.round((completed / total) * 100);			
	}
	_this.getCourseComPercentage = function(){
		var completed = 0;
		var total = 0; 
		for(var i=0; i<screenDataArray.length; i++){
			for(var j=0; j<screenDataArray[i].tp.length; j++){
				//--check only mandatory mod data
				var dt = screenDataArray[i].tp[j].dt;
				
				if(dt == 'md'){
					total += screenDataArray[i].tp[j].sc.length;
					for(var k=0; k<screenDataArray[i].tp[j].sc.length; k++){
						var curr = screenDataArray[i].tp[j].sc[k];
						if(curr.st == '2'){
							completed ++;
						}
					}
				}
			}			
		}
		
		return Math.round((completed / total) * 100);	
	}
	_this.isAllScreenCompleted = function(){
		var complete = true;
		for(var i=1; i<screenDataArray.length; i++){
			for(var j=0; j<screenDataArray[i].tp.length; j++){
				for(var k=0; k<screenDataArray[i].tp[j].sc.length; k++){
					var curr = screenDataArray[i].tp[j].sc[k];
					if(curr.st != '2'){
						complete = false;
						break;
					}
				}
			}			
		}
		return complete;
	}
	_this.resetAllScreenData = function () {
		for (var i = 1; i < screenDataArray.length; i++) {
			for (var j = 0; j < screenDataArray[i].tp.length; j++) {
				for (var k = 0; k < screenDataArray[i].tp[j].sc.length; k++) {
					var curr = screenDataArray[i].tp[j].sc[k];
					curr.st = '0';
					if(curr.ud){
						curr.ud = '';
					}					
				}
			}
		}
		_this.updateAllModuleStatus();
		APP.dataComObj.updateUserData();
	}
	_this.isCustomAllTopicCompleted = function(){
		var modId = 1;
		var topicArr = [0,1,2,3];
		var complete = true;
		for(var i=0; i<topicArr.length; i++){
			complete = _this.isTopicComplete(modId, topicArr[i]);
			
			if(!complete){
				break;
			}
		}
		return complete;
	}	
	_this.isAllMandatoryTopicCompleted = function(){
		var isAllCompleted = false;
		var tot = _this.getTotalMandatoryTopicCount();
		var com = _this.getTotalMandatoryCompleteTopicCount();
		
		if(tot != null && com != null){
			if(com >= tot){
				isAllCompleted = true;
			}
		}		
		return isAllCompleted;
	}
	_this.validatePrevData = function(){
		if(APP.commonFunObj.isScorm()){
			var prevData = APP.dataComObj.getSuspendData();
			//prevData = 'fr'+"-#-"+'rtl'+"-#-"+'0,1,0,1'+"-#-"+''+"-#-"+'1_0_1';
			_this.createCourseData(prevData);
			
		}else{
			//prevData = 'fr'+"-#-"+'rtl'+"-#-"+'0,1,0,1'+"-#-"+''+"-#-"+'1_0_1';
			_this.createCourseData('');		
		}
		_this.checkLang();
			
	}
	//-- not fully checked
	_this.checkLang = function(){
		if(_this.isLangChange().isDirChanged){			
			_this.changeDirWiseFileLocation();
			APP.langChanged = true;			
		};
		if(_this.isLangChange().isLangChanged){			
			APP.langChanged = true;			
		};
		if(APP.langChanged == true){
			APP.globalXmlsObj.loadGlobalXML();
		}else{
			//--for initial load
			APP.courseDataObj.applyUserProfile();
			APP.courseDataObj.checkBookmark();
		}
	}
	_this.isLangChange = function(){
		var obj = {
			isLangChanged: false,
			isDirChanged: false
		};
		if(APP.prevLanguageObj){
			if(APP.prevLanguageObj.lang != APP.configObj.language.lang){
				obj.isLangChanged = true;
			}
			if(APP.prevLanguageObj.dir != APP.configObj.language.dir){
				obj.isDirChanged = true;
			}
		}
		
		return obj;
	}	
	_this.checkBookmark = function(){
    APP.langChanged = false;
		if(APP.prevBookmark!=null && APP.prevBookmark!=""){
			if(APP.prevBookmark.indexOf('_') != -1){
				var t=APP.prevBookmark.split('_');
				APP.navData.moduleId=parseInt(t[0]);
				APP.navData.topicId=parseInt(t[1]);
				APP.navData.screenId=parseInt(t[2]);
			}
			if(!APP.globalMessageOpen){
				APP.commonFunObj.showBookmarkPop();
			}
		}else{
			if(!APP.globalMessageOpen){
				APP.navigationObj.loadScreen();
			}
		}
		
	}
	_this.changeDirWiseFileLocation = function(){
		if(APP.configObj.language.dir != ''){
			$('#screen-container').attr('class', 'screen-container').hide();
			APP.preloaderObj.show();
			var cssLink=document.getElementsByTagName('link'); 
			for (var i in cssLink) {
				if(cssLink[i].href !=null && cssLink[i].href!=""){
					var str=cssLink[i].href;
					if(str.indexOf('/framework/')>=0){
						var relPath = str.substring(str.lastIndexOf("/framework/") + 1, str.length);
						if(APP.configObj.language.dir == 'rtl'){
							cssLink[i].href=relPath.replace('/ltr/','/rtl/');
						}else{
							cssLink[i].href=relPath.replace('/rtl/','/ltr/');
						}				
					}else if(str.indexOf('/content/')>=0){
						var relPath = str.substring(str.lastIndexOf("/content/") + 1, str.length);						
						if(APP.configObj.language.dir == 'rtl'){
							cssLink[i].href=relPath.replace('/ltr/','/rtl/');
						}else{
							cssLink[i].href=relPath.replace('/rtl/','/ltr/');
						}
					}					
				}					
			}
			APP.preloaderObj.hide();
		}
	}
	//--custom function
	_this.applyUserProfile = function(){		
		if(APP.globalXmlsObj.globalXML == null){return false;}	
		//-- 1st apply all mandatory
		
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		for(var i=0; i<modObj.length; i++){
			var topicObj= modObj[i].topic;
			var type = modObj[i].moduleType || '';
			//skip logic for intro module
			if( type == 'intro'){
				continue;
			}					
			for(var j=0; j<topicObj.length; j++){
				var curr = topicObj[j];
				curr.dataType = 'mandatory';
				screenDataArray[i].tp[j].dt = 'md';
				if(curr.profiler1RelatedQueId != null && curr.profiler1RelatedQueId != ''){	
					curr.dataType = 'optional';
					screenDataArray[i].tp[j].dt = 'op';
				}
				if(curr.profiler2RelatedQueId != null && curr.profiler2RelatedQueId != ''){	
					curr.dataType = 'optional';
					screenDataArray[i].tp[j].dt = 'op';
				}
			}
		}
		
	}
	_this.isTopicMandatory = function(_obj){
		if(APP.globalXmlsObj.globalXML == null){return 0;}
		var obj = _obj || APP.navData;		
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		
		var _type = modObj[obj.moduleId].topic[obj.topicId].dataType;
		
		if(_type == 'mandatory'){
			return true;
		}else{
			return false;
		}
	
	}
	_this.isScreenMandatory = function(_id){
		if(APP.globalXmlsObj.globalXML == null){return 0;}
		var obj = APP.navigationObj.getScreenById(_id);
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		
		var _type = modObj[obj.moduleId].topic[obj.topicId].dataType;
		
		if(_type == 'mandatory'){
			return true;
		}else{
			return false;
		}
	};

	_this.getTotalDuration = function(){
		if(APP.globalXmlsObj.globalXML == null){return 0;}
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		var total = 0;
		for(var i=0; i<modObj.length; i++){
			var topicObj= modObj[i].topic;
			var type = modObj[i].moduleType || '';
			//skip logic for intro module
			if( type == 'intro'){
				continue;
			}					
			for(var j=0; j<topicObj.length; j++){
				var curr = topicObj[j];
				if(curr.dataType == 'mandatory'){
					var min = curr.durationMin;
					if(min != null && min != ''){
						total += parseFloat(min);
					}						
				}					
			}
		}
		return total.toFixed(2);
	}
	_this.getTotalOptionalModuleCount = function(){
		if(APP.globalXmlsObj.globalXML == null){return null;}
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		var total = 0;
		for(var i=0; i<modObj.length; i++){
			var topicObj= modObj[i].topic;
			var type = modObj[i].moduleType || '';
			//skip logic for intro module
			if( type == 'intro'){
				continue;
			}					
			for(var j=0; j<topicObj.length; j++){
				var curr = topicObj[j];
				if(curr.dataType == 'optional'){					
					total += 1											
				}					
			}
		}
		return total;
	}
	
	_this.getTotalMandatoryTopicCount = function(){
		if(APP.globalXmlsObj.globalXML == null){return null;}
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		var total = 0;
		for(var i=0; i<modObj.length; i++){
			var topicObj= modObj[i].topic;
			var type = modObj[i].moduleType || '';
			//skip logic for intro module
			if( type == 'intro'){
				continue;
			}					
			for(var j=0; j<topicObj.length; j++){
				var curr = topicObj[j];
				if(curr.dataType == 'mandatory'){					
					total += 1											
				}					
			}
		}
		return total;
	}
	_this.getTotalMandatoryCompleteTopicCount = function(){
		if(APP.globalXmlsObj.globalXML == null){return null;}
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		var total = 0;
		for(var i=0; i<modObj.length; i++){
			var topicObj= modObj[i].topic;
			var type = modObj[i].moduleType || '';
			//skip logic for intro module
			if( type == 'intro'){
				continue;
			}					
			for(var j=0; j<topicObj.length; j++){
				var curr = topicObj[j];
				if(curr.dataType == 'mandatory'){	
					if(_this.isTopicComplete(i,j)){
						total += 1;
					}										
				}					
			}
		}
		return total;
	}
	_this.getTotalModuleCount = function(){
		if(APP.globalXmlsObj.globalXML == null){return null;}
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		var total = 0;
		for(var i=0; i<modObj.length; i++){			
			var type = modObj[i].moduleType || '';
			//skip logic for intro module
			if( type == 'intro'){
				continue;
			}				
			total += 1;	
		}
		return total;
	}
	_this.getTotalCompletedModuleCount = function(){
		if(APP.globalXmlsObj.globalXML == null){return null;}
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		var total = 0;
		for(var i=0; i<modObj.length; i++){			
			var type = modObj[i].moduleType || '';
			//skip logic for intro module
			if( type == 'intro'){
				continue;
			}					
			if(_this.isModuleComplete(i)){
				total += 1;
			}
		}
		return total;
	}
	_this.getNextMandatoryTopicId = function(_obj){
		var obj = _obj || APP.navData;
		var topicObj = APP.globalXmlsObj.globalXML.menu[0].module[_obj.moduleId].topic;
		var nextMandatoryTopicId = null;							
		for(var j=_obj.topicId; j<topicObj.length; j++){
			//to skip current topic
			if( j == _obj.topicId){
				continue;
			}
			var curr = topicObj[j];
			if(curr.dataType == 'mandatory'){					
				nextMandatoryTopicId = j;
				break;											
			}					
		}		
		return nextMandatoryTopicId;
	}
	_this.getPrevMandatoryTopicId = function(_obj){
		var obj = _obj || APP.navData;
		var topicObj = APP.globalXmlsObj.globalXML.menu[0].module[obj.moduleId].topic;
		var prevMandatoryTopicId = null;							
		for(var j=_obj.topicId; j>=0; j--){
			
			//to skip current topic
			if( j == _obj.topicId){
				continue;
			}
			var curr = topicObj[j];
			if(curr.dataType == 'mandatory'){					
				prevMandatoryTopicId = j;
				break;											
			}							
		}		
		
		return prevMandatoryTopicId;
	}
	_this.getPrevScreenIdforBackTopic = function (_obj){
		var obj = _obj || APP.navData;
		var screenObj = APP.globalXmlsObj.navigationXML.module[obj.moduleId].topic[obj.topicId].screen;
		var avlScreenId = null;							
		for(var j=_obj.screenId; j>=0; j--){			
			var curr = screenObj[j];
			
			if(curr.skipInBack === 'true'){					
															
			}else{
				avlScreenId = j;
				break;
			}							
		}		
			
		return avlScreenId;
	}
	_this.getTopicDuration = function(_obj){
		var obj = _obj || APP.navData;
		var duration = APP.globalXmlsObj.globalXML.menu[0].module[obj.moduleId].topic[obj.topicId].durationMin || '';
		return duration;
	}
	_this.initGlobalQuizObj = function(){
		var id = 0;
		var count = 0;
		var isAvl = false;
		if(APP.configObj.assessment){
			for(var i=0; i<APP.configObj.assessment.length; i++){
				var curr = APP.configObj.assessment[i];
				if(curr.isAvailable){
					if(id == 0){
						id = i;
					}					
					count++;
					isAvl = true;
				}
			}
		}
		APP.globalQuizObj = {
			currentQuizId:id,
			totalAvlQuiz:count,
			isAvalable:isAvl,
			globalAttempt:0,
		}
		_this.initAllAssessmentData();
	}
	_this.initAllAssessmentData = function (){
		if(APP.configObj.assessment){
			for(var i=0; i<APP.configObj.assessment.length; i++){
				_this.initAssessmentData(i);
			}
		}
	}
	_this.initAssessmentData = function (id){
		if(APP.configObj.assessment){			
			var curr = APP.configObj.assessment[id];
			if(curr.isAvailable){
				curr.dataCurrentAttempt = 0;
				curr.dataCurrentQue = 0;
				curr.dataCurrentPoint = 0;
				curr.dataPercentage = "";			
				curr.dataStatus = "";
				curr.dataPassDate = "";
				curr.dataReviewMode = false;
				curr.dataTimeOut = false;
				curr.dataTotalQue = 0;
				curr.dataCorrQueCount = 0;
				curr.dataDisplayTime = 0;
				curr.dataRemainingTime = 0;
				curr.dataRandomArr = [];
				curr.dataUserQuizData = [];
				curr.dataFinalAssessmentObj = [];
			}			
		}
	}
	_this.resetAssessmentData = function (id) {
		if(APP.configObj.assessment){			
			var curr = APP.configObj.assessment[id];
			if(curr.isAvailable){
				curr.dataCurrentQue=0;
				curr.dataCurrentPoint=0;
				curr.dataPercentage="";
				curr.dataStatus="";
				curr.dataReviewMode=false;
				curr.dataTimeOut=false;
				curr.dataTotalQue=0;
				curr.dataCorrQueCount=0;
				_this.resetFinalAssessmentObj(id);
				APP.globalXmlsObj.createRandomizeQuizArray(id);
			}
			
		}
	}
	_this.resetFinalAssessmentObj=function(id){
		if(APP.configObj.assessment){			
			var curr = APP.configObj.assessment[id];
			if(curr.isAvailable){
				var obj = curr.dataFinalAssessmentObj;
				if (obj != null) {
					for (var i = 0; i < obj.length; i++) {
						delete obj[i].dataAnswerArray;
						delete obj[i].dataEarnPoint;
						delete obj[i].dataIsUserOptionSelected;
						delete obj[i].dataStatus;
						delete obj[i].dataUserArray;
						delete obj[i].dataId;
						delete obj[i].dataQuePoint;
						delete obj[i].dataStartTime;
						
					}
				}
			}
		}		
	}
	_this.preloadScreenBgImgs = function(){
		var prePath = 'content/images/'+APP.configObj.language.dir;
		var screenBgImgs = [];
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;		
		for(var i=0; i<modObj.length; i++){
			var _bgImg = modObj[i].bgImg;
			if(_bgImg) {
				if(_bgImg.indexOf(".jpg") != -1 || _bgImg.indexOf(".png") != -1){
					screenBgImgs.push(prePath+'/'+_bgImg);
				} 
			}
			var topicObj = modObj[i].topic;		
			for(var j=0; j<topicObj.length; j++){
				var _bgImg = topicObj[j].bgImg;
				if(_bgImg) {
					if(_bgImg.indexOf(".jpg") != -1 || _bgImg.indexOf(".png") != -1){
						screenBgImgs.push(prePath+'/'+_bgImg);
					} 
				}
				var screenObj=topicObj[j].screen;							
				for(var k=0; k<screenObj.length; k++){
					var _bgImg = screenObj[k].bgImg;
					if(_bgImg) {
						if(_bgImg.indexOf(".jpg") != -1 || _bgImg.indexOf(".png") != -1){
							screenBgImgs.push(prePath+'/'+_bgImg);
						} 
					}
				}
			}
		}
		var arr = APP.commonFunObj.removeDuplicatesFromArr(screenBgImgs);
		
		if(arr.length){
			APP.commonFunObj.preloadImages(arr);
		}
	}
	_this.getScreenBgPath = function(_obj){
		var obj = _obj || APP.navData;
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		var prePath = 'content/images/'+APP.configObj.language.dir;
		var bgImg = "";
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module[obj.moduleId]
		if(modObj.bgImg != null && modObj.bgImg != ''){
			bgImg = prePath+'/'+modObj.bgImg;			
		}
		var topicObj = modObj.topic[obj.topicId];
		if(topicObj.bgImg != null && topicObj.bgImg != ''){
			bgImg = prePath+'/'+topicObj.bgImg;			
		}
		var screenObj = topicObj.screen[obj.screenId];
		if(screenObj.bgImg != null && screenObj.bgImg != ''){
			bgImg = prePath+'/'+screenObj.bgImg;			
		}
		return bgImg;
	}
	_this.getScreenBgStyle = function(_obj){
		var obj = _obj || APP.navData;
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		
		var _style = "";
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module[obj.moduleId]
		
		var topicObj = modObj.topic[obj.topicId];
		
		var screenObj = topicObj.screen[obj.screenId];
		if(screenObj.bgStyle != null && screenObj.bgStyle != ''){
			_style = screenObj.bgStyle;			
		}
		return _style;
	}
	_this.getScreenBgVideoPath = function(_obj){
		var obj = _obj || APP.navData;
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module;
		var prePath = APP.configObj.filePath.langFolderPath + APP.configObj.language.lang;
		var bgVid = "";
		var modObj = APP.globalXmlsObj.globalXML.menu[0].module[obj.moduleId]
		if(modObj.bgVid != null && modObj.bgVid != ''){
			bgVid = prePath+'/'+modObj.bgVid;			
		}
		var topicObj = modObj.topic[obj.topicId];
		if(topicObj.bgVid != null && topicObj.bgVid != ''){
			bgVid = prePath+'/'+topicObj.bgVid;			
		}
		var screenObj = topicObj.screen[obj.screenId];
		if(screenObj.bgVid != null && screenObj.bgVid != ''){
			bgVid = prePath+'/'+screenObj.bgVid;			
		}
		return bgVid;
	}
	
	_this.createInlineQuizObj = function(){
		APP.inlineQuizObj.tsc = '';
		APP.inlineQuizObj.tot= 0;
		APP.inlineQuizObj.msarr = [];
		var mCount = 0;
		var count = 0;
		var modObj = APP.globalXmlsObj.navigationXML.module;		
		for(var i=0; i<modObj.length; i++){
			if(modObj[i].moduleType === 'mission'){
				APP.inlineQuizObj.msarr[mCount] = {
					mid: modObj[i].missionId || mCount,
					msc: '',
					
					sma:[]
				};
				var topicObj=modObj[i].topic;
				var _smaObj = []				
				for(var j=0; j<topicObj.length; j++){
					var screenObj=topicObj[j].screen;								
					for(var k=0; k<screenObj.length; k++){
						var curr = screenObj[k];
						if(curr.isMissionActivity === 'true'){
							APP.inlineQuizObj.tot += 1;
							_smaObj.push({
								scid: curr.screenId,
								smsc: '',
								isc: ''
							})
							
						}
					}					
				}	
				APP.inlineQuizObj.msarr[mCount].sma = _smaObj;
				mCount++;
			}			
		}	
		calInlineQuizObj();			
		//APP.commonFunObj.animateGbScoreAndPoint();
		//APP.commonFunObj.updateScoreTxt();
		//APP.commonFunObj.updateTrophyTxt();
	}
	/* updateInlineQuizObj _obj={
		scid: '2_1_10',
		smsc: +10,
		isc: '2'
	} */
	_this.updateInlineQuizObj = function(_obj){
		var arrIndex = getMissonIndex(_obj.scid);
		//console.log(arrIndex.missionIndex, arrIndex.subMissionIndex)
		//console.log(arrIndex.missionIndex != null, arrIndex.missionIndex !=='')
		if(arrIndex.missionIndex != null && arrIndex.missionIndex !==''){			
			if(arrIndex.subMissionIndex != null && arrIndex.subMissionIndex !==''){				
				if(_obj.smsc != null){APP.inlineQuizObj.msarr[arrIndex.missionIndex].sma[arrIndex.subMissionIndex].smsc = _obj.smsc}
				if(_obj.isc != null){APP.inlineQuizObj.msarr[arrIndex.missionIndex].sma[arrIndex.subMissionIndex].isc = _obj.isc}				
			}
		}
		calInlineQuizObj();
	}
  	_this.resetInlineQuizData = function(){
		_this.createInlineQuizObj();
	}	
	_this.getMissionData = function(_moduleId){
		var moduleId = _moduleId || APP.navData.moduleId;
		var missionId = APP.globalXmlsObj.navigationXML.module[moduleId].missionId;
		//console.log('missionId: '+missionId)
		if(missionId){
			for(var i=0; i<APP.inlineQuizObj.msarr.length; i++){
				var currMs = APP.inlineQuizObj.msarr[i];
				if(missionId == currMs.mid){return currMs;}
			}	
		}
	}
	_this.getSubMissionData = function(_obj){
		var obj = _obj || APP.navData;
		var screenObj = APP.globalXmlsObj.navigationXML.module[obj.moduleId].topic[obj.topicId].screen[obj.screenId];
		var arrIndex = getMissonIndex(screenObj.screenId);
		//console.log('arrIndex.missionIndex: '+arrIndex.missionIndex)
		if(arrIndex.missionIndex != null && arrIndex.missionIndex !==''){			
			if(arrIndex.subMissionIndex != null && arrIndex.subMissionIndex !==''){	
				return APP.inlineQuizObj.msarr[arrIndex.missionIndex].sma[arrIndex.subMissionIndex];
			}
		}
	}
	_this.isAnyMissionTaskAccessed = function(){
		var isAnyAccessed = false;
		for(var i=0; i<APP.inlineQuizObj.msarr.length; i++){
			var currMs = APP.inlineQuizObj.msarr[i];			
			for(var j=0; j<currMs.sma.length; j++){
				var currSm = currMs.sma[j];
				if(currSm.smsc != null && currSm.smsc !== ''){
					isAnyAccessed = true;
					break;
				}				
			}
			if(isAnyAccessed){break;}
		} 
		return isAnyAccessed;
	}
	function getMissonIndex(_scid){
		var isFound = false;
		var obj = {
			missionIndex: '',
			subMissionIndex: '',
		}
		for(var i=0; i<APP.inlineQuizObj.msarr.length; i++){
			for(var j=0; j<APP.inlineQuizObj.msarr[i].sma.length; j++){
				var curr = APP.inlineQuizObj.msarr[i].sma[j];
				if(curr.scid === _scid){
					obj.missionIndex = i;
					obj.subMissionIndex = j;
					isFound = true;
					break;
				}
				
			}
			if(isFound){break;}
		} 
		return obj;
	}
	function calInlineQuizObj (){
		APP.prevScoreAndPoint.totalScore = APP.inlineQuizObj.tsc;
		
		for(var i=0; i<APP.inlineQuizObj.msarr.length; i++){
			var currMs = APP.inlineQuizObj.msarr[i];
			//--mission score
			currMs.msc= 0;
			
			var corrQue = 0;
			for(var j=0; j<currMs.sma.length; j++){
				var currSm = currMs.sma[j];
				if(currSm.smsc != null && currSm.smsc !== ''){currMs.msc += currSm.smsc}
				if(currSm.isc == '2'){corrQue++;}
			}
			
		} 
		//--for global points
		//--total score
		APP.inlineQuizObj.tsc= 0;
		

		for(var i=0; i<APP.inlineQuizObj.msarr.length; i++){
			var currMs = APP.inlineQuizObj.msarr[i];
			if(currMs.msc != null && currMs.msc !== ''){APP.inlineQuizObj.tsc += currMs.msc}
			
		}
		//--
	}
	function initData (){
		screenDataArray=[];	
		
		var modObj = APP.globalXmlsObj.navigationXML.module;		
		for(var i=0; i<modObj.length; i++){
			var topicObj=APP.globalXmlsObj.navigationXML.module[i].topic;
			var type = APP.globalXmlsObj.navigationXML.module[i].moduleType || '';
			var mObj = {
				/* id: i, */
				/* ty: type, */
				st: '0',
				tp: []
			}
			for(var j=0; j<topicObj.length; j++){
				var screenObj=APP.globalXmlsObj.navigationXML.module[i].topic[j].screen;
				var sObj = {
					/* id: j, */
					st: '0',
					dt: 'md',
					sc: []
				}				
				for(var k=0; k<screenObj.length; k++){
					var pObj = {						
						st: '0'
					}
					sObj.sc.push(pObj);
				}
				mObj.tp.push(sObj);
			}
			screenDataArray.push(mObj);
		}	
		APP.coursePassDate = '';
		APP.prevBookmark = '';
		_this.initAllAssessmentData();
		_this.updateAllModuleStatus();
		_this.createInlineQuizObj();
		//APP.test101 = screenDataArray;
	}
	function applyPrevQuizData(){
		
		var obj= APP.userQuizData;
		if(obj.length){
			for(var i=0; i<obj.length; i++){
				var curr = obj[i];
				if(curr.ra != null && curr.ra.length){
					APP.configObj.assessment[i].dataRandomArr = curr.ra;
					APP.globalXmlsObj.applyXmlObjInFinalAssessment(i);
				}
				if(curr.pr != null){
					APP.configObj.assessment[i].dataPercentage = curr.pr;
				}
				if(curr.rs != null){
					APP.configObj.assessment[i].dataStatus = curr.rs;
				}
				if(curr.cq != null){
					APP.configObj.assessment[i].dataCorrQueCount = curr.cq;
				}
				if(curr.tq != null){
					APP.configObj.assessment[i].dataTotalQue = curr.tq;
				}
				var dataFinalAssessmentObj = APP.configObj.assessment[i].dataFinalAssessmentObj;
				if(curr.fa != null && dataFinalAssessmentObj.length){
					for(var j=0; j<curr.fa.length; j++){
						if(curr.fa[j].ans != null){
							dataFinalAssessmentObj[j].dataAnswerArray = curr.fa[j].ans;
						}						
						/* if(curr.fa[j].ep != null){
							dataFinalAssessmentObj[j].dataEarnPoint = curr.fa[j].ep;
						} */
						
						if(curr.fa[j].id != null){
							dataFinalAssessmentObj[j].dataId = curr.fa[j].id;
						}
						if(curr.fa[j].uos != null){
							dataFinalAssessmentObj[j].dataIsUserOptionSelected = curr.fa[j].uos;
						}
						/* if(curr.fa[j].sts != null){
							dataFinalAssessmentObj[j].dataStatus = curr.fa[j].sts;
						}	 */						
						if(curr.fa[j].ua != null){
							dataFinalAssessmentObj[j].dataUserArray = curr.fa[j].ua;
						}
						/* if(curr.fa[j].qp != null){
							dataFinalAssessmentObj[j].dataQuePoint = curr.fa[j].qp;
						} */
					}
				}
			}
		}		
	}
	
	function updateUserQuizData(){	
		
		APP.userQuizData = [];
		if(APP.globalQuizObj.isAvalable){
			for(var i=0; i<APP.configObj.assessment.length; i++){
				APP.userQuizData[i]={};
				var curr = APP.configObj.assessment[i];
				if(curr.isAvailable){					
					if(curr.dataRandomArr){
						APP.userQuizData[i].ra = curr.dataRandomArr;
					}
					APP.userQuizData[i].pr = curr.dataPercentage;
					APP.userQuizData[i].rs = curr.dataStatus;
					APP.userQuizData[i].cq = curr.dataCorrQueCount;
					APP.userQuizData[i].tq = curr.dataTotalQue;	

					var obj = curr.dataFinalAssessmentObj;
					if(obj){
						//these data mainly used for result screen after bookmarking
						APP.userQuizData[i].fa=[];
						for(var j=0; j<obj.length; j++){	
							APP.userQuizData[i].fa[j] = {};						
							if(obj[j].dataAnswerArray != null){
								APP.userQuizData[i].fa[j].ans=obj[j].dataAnswerArray;
							}
							/* if(obj[j].dataEarnPoint != null){
								APP.userQuizData[i].fa[j].ep=obj[j].dataEarnPoint;
							} */
							if(obj[j].dataId != null){
								APP.userQuizData[i].fa[j].id=obj[j].dataId;
							}
							if(obj[i].dataIsUserOptionSelected != null){
								APP.userQuizData[i].fa[j].uos=obj[j].dataIsUserOptionSelected;
							}
							/* if(obj[i].dataStatus != null){
								APP.userQuizData[i].fa[j].sts=obj[j].dataStatus;
							}	 */						
							if(obj[i].dataUserArray != null){
								APP.userQuizData[i].fa[j].ua=obj[j].dataUserArray;
							}
							/* if(obj[i].dataQuePoint != null){
								APP.userQuizData[i].fa[j].qp=obj[j].dataQuePoint;
							} */
						}
					}
									
				}
			}
		}
			
	}
}